// (C) 2017-2020 by folkert van heusden, released under AGPL v3.0
#pragma once

#include <stdint.h>

#include "filter.h"
#include "meta.h"
#include "selection_mask.h"

typedef enum { m_red, m_red_invert, m_invert } sm_mode_t;

typedef enum { t_box, t_cross, t_circle, t_border } sm_type_t;

void update_pixel(uint8_t *const out, const int x, const int y, const int w);

class filter_marker_simple : public filter
{
private:
	const sm_mode_t mode;
	const sm_type_t type;
	selection_mask *const pixel_select_bitmap;
	meta *const m;
	const int noise_level;
	const double percentage_pixels_changed;
	const int thick;
	instance_t *const i;

	std::atomic_bool changed { false };

public:
	filter_marker_simple(instance_t *const i, const sm_mode_t modeIn, const sm_type_t type, selection_mask *const sb, meta *const m, const int noise_level, const double percentage_pixels_changed, const int thick);
	virtual ~filter_marker_simple();

	void notify_thread_of_event() override;

	bool uses_in_out() const override { return false; }
	void apply(instance_t *const i, interface *const specific_int, const uint64_t ts, const int w, const int h, const uint8_t *const prev, uint8_t *const in_out) override;
};
